/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of CairoSurface.xs. Do not edit this file, edit CairoSurface.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "CairoSurface.xs"
/*
 * Copyright (c) 2004-2006 by the cairo perl team (see the file README)
 *
 * Licensed under the LGPL, see LICENSE file for more information.
 *
 * $Header: /cvs/cairo/cairo-perl/CairoSurface.xs,v 1.25 2008-02-10 18:36:33 tsch Exp $
 */

#include <cairo-perl.h>
#include <cairo-perl-private.h>

#define NEED_sv_2pv_flags
#include "ppport.h"

#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)

static HV *pointer_to_package = NULL;

/* A hex character represents four bits in the address of a pointer, so we'll
 * need BITS_PER_LONG/4 characters.  That's sizeof (long) * 2.  Add 2 for the
 * "0x" part.  Add 1 for the trailing \0.  Reasoning courtesy of Robert Love.
 */
#define MAX_KEY_LENGTH ((sizeof(long) * 2) + 2 + 1)

/* This stuff is also used in CairoPattern.xs, hence no static on the
 * functions.
 */

void
cairo_perl_package_table_insert (void *pointer, const char *package)
{
	char key[MAX_KEY_LENGTH];

	if (!pointer_to_package) {
		pointer_to_package = newHV ();
	}

	sprintf (key, "%p", pointer);
	hv_store (pointer_to_package, key, strlen (key), newSVpv (package, PL_na), 0);
}

const char *
cairo_perl_package_table_lookup (void *pointer)
{
	char key[MAX_KEY_LENGTH];
	SV **sv;

	if (!pointer_to_package) {
		return NULL;
	}

	sprintf (key, "%p", pointer);
	sv = hv_fetch (pointer_to_package, key, strlen (key), 0);
	if (sv && SvOK (*sv)) {
		return SvPV_nolen (*sv);
	}

	return NULL;
}

#endif /* !1.2.0 */

static const char *
get_package (cairo_surface_t *surface)
{
#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_surface_type_t type;
	const char *package;

	type = cairo_surface_get_type (surface);
	switch (type) {
	    case CAIRO_SURFACE_TYPE_IMAGE:
		package = "Cairo::ImageSurface";
		break;

	    case CAIRO_SURFACE_TYPE_PDF:
		package = "Cairo::PdfSurface";
		break;

	    case CAIRO_SURFACE_TYPE_PS:
		package = "Cairo::PsSurface";
		break;

	    case CAIRO_SURFACE_TYPE_SVG:
		package = "Cairo::SvgSurface";
		break;

	    case CAIRO_SURFACE_TYPE_XLIB:
	    case CAIRO_SURFACE_TYPE_XCB:
	    case CAIRO_SURFACE_TYPE_GLITZ:
	    case CAIRO_SURFACE_TYPE_QUARTZ:
	    case CAIRO_SURFACE_TYPE_WIN32:
	    case CAIRO_SURFACE_TYPE_BEOS:
	    case CAIRO_SURFACE_TYPE_DIRECTFB:
		package = "Cairo::Surface";
		break;

	    default:
		warn ("unknown surface type %d encountered", type);
		package = "Cairo::Surface";
		break;
	}

	return package;
#else
	const char *package = cairo_perl_package_table_lookup (surface);
	return package ? package : "Cairo::Surface";
#endif
}

SV *
cairo_surface_to_sv (cairo_surface_t *surface)
{
	SV *sv = newSV (0);
	sv_setref_pv(sv, get_package (surface), surface);
	return sv;
}

/* -------------------------------------------------------------------------- */

typedef struct {
	SV *func;
	SV *data;
	void *context;
} CairoPerlCallback;

#ifdef PERL_IMPLICIT_CONTEXT
# define dCAIRO_PERL_CALLBACK_MARSHAL_SP		\
	SV ** sp;
# define CAIRO_PERL_CALLBACK_MARSHAL_INIT(callback)	\
	PERL_SET_CONTEXT (callback->context);		\
	SPAGAIN;
#else
# define dCAIRO_PERL_CALLBACK_MARSHAL_SP		\
	dSP;
# define CAIRO_PERL_CALLBACK_MARSHAL_INIT(callback)	\
	/* nothing to do */
#endif

static CairoPerlCallback *
cairo_perl_callback_new (SV *func, SV *data)
{
	CairoPerlCallback *callback;

	Newz (0, callback, 1, CairoPerlCallback);

	callback->func = newSVsv (func);
	if (data)
		callback->data = newSVsv (data);

#ifdef PERL_IMPLICIT_CONTEXT
	callback->context = aTHX;
#endif

	return callback;
}

static void
cairo_perl_callback_free (CairoPerlCallback *callback)
{
	SvREFCNT_dec (callback->func);
	if (callback->data)
		SvREFCNT_dec (callback->data);
	Safefree (callback);
}

/* -------------------------------------------------------------------------- */

static cairo_status_t
write_func_marshaller (void *closure,
                       const unsigned char *data,
                       unsigned int length)
{
	CairoPerlCallback *callback;
	cairo_status_t status = CAIRO_STATUS_SUCCESS;
	dCAIRO_PERL_CALLBACK_MARSHAL_SP;

	callback = (CairoPerlCallback *) closure;

	CAIRO_PERL_CALLBACK_MARSHAL_INIT (callback);

	ENTER;
	SAVETMPS;
	PUSHMARK (SP);

	EXTEND (SP, 2);
	PUSHs (callback->data ? callback->data : &PL_sv_undef);
	PUSHs (sv_2mortal (newSVpv ((const char *) data, length)));

	PUTBACK;
	call_sv (callback->func, G_DISCARD | G_EVAL);
	SPAGAIN;

	if (SvTRUE (ERRSV)) {
		status = SvCairoStatus (ERRSV);
	}

	PUTBACK;
	FREETMPS;
	LEAVE;

	return status;
}

/* -------------------------------------------------------------------------- */

static cairo_status_t
read_func_marshaller (void *closure,
                      unsigned char *data,
                      unsigned int length)
{
	CairoPerlCallback *callback;
	cairo_status_t status = CAIRO_STATUS_SUCCESS;
	dCAIRO_PERL_CALLBACK_MARSHAL_SP;

	callback = (CairoPerlCallback *) closure;

	CAIRO_PERL_CALLBACK_MARSHAL_INIT (callback);

	ENTER;
	SAVETMPS;
	PUSHMARK (SP);

	EXTEND (SP, 2);
	PUSHs (callback->data ? callback->data : &PL_sv_undef);
	PUSHs (sv_2mortal (newSVuv (length)));

	PUTBACK;
	call_sv (callback->func, G_SCALAR | G_EVAL);
	SPAGAIN;

	if (SvTRUE (ERRSV)) {
		status = SvCairoStatus (ERRSV);
	} else {
		SV *retval = POPs;
		memcpy (data, SvPV_nolen (retval), sv_len (retval));
	}

	PUTBACK;
	FREETMPS;
	LEAVE;

	return status;
}

/* -------------------------------------------------------------------------- */

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 262 "CairoSurface.c"

XS(XS_Cairo__Surface_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::DESTROY", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
#line 252 "CairoSurface.xs"
	cairo_surface_destroy (surface);
#line 279 "CairoSurface.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__Surface_create_similar); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_create_similar)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::create_similar", "other, content, width, height");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t_noinc *	RETVAL;
	cairo_surface_t *	other = SvCairoSurface (ST(0));
	cairo_content_t	content = SvCairoContent (ST(1));
	int	width = (int)SvIV(ST(2));
	int	height = (int)SvIV(ST(3));

	RETVAL = cairo_surface_create_similar(other, content, width, height);
#line 256 "CairoSurface.xs"
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
    {
	const char *package = cairo_perl_package_table_lookup (other);
	cairo_perl_package_table_insert (RETVAL, package ? package : "Cairo::Surface");
    }
#endif
#line 311 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__Surface_finish); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_finish)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::finish", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_surface_finish(surface);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__Surface_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_status)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::status", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_status_t	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_surface_status(surface);
	ST(0) = newSVCairoStatus (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__Surface_set_device_offset); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_set_device_offset)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::set_device_offset", "surface, x_offset, y_offset");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	double	x_offset = (double)SvNV(ST(1));
	double	y_offset = (double)SvNV(ST(2));

	cairo_surface_set_device_offset(surface, x_offset, y_offset);
    }
    XSRETURN_EMPTY;
}

#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
#define XSubPPtmpAAAA 1


XS(XS_Cairo__Surface_get_device_offset); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_get_device_offset)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::get_device_offset", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	double	x_offset;
	double	y_offset;

	cairo_surface_get_device_offset(surface, &x_offset, &y_offset);
	XSprePUSH;	EXTEND(SP,2);
	PUSHs(sv_newmortal());
	sv_setnv(ST(0), (double)x_offset);
	PUSHs(sv_newmortal());
	sv_setnv(ST(1), (double)y_offset);
    }
    XSRETURN(2);
}


XS(XS_Cairo__Surface_set_fallback_resolution); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_set_fallback_resolution)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::set_fallback_resolution", "surface, x_pixels_per_inch, y_pixels_per_inch");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	double	x_pixels_per_inch = (double)SvNV(ST(1));
	double	y_pixels_per_inch = (double)SvNV(ST(2));

	cairo_surface_set_fallback_resolution(surface, x_pixels_per_inch, y_pixels_per_inch);
    }
    XSRETURN_EMPTY;
}

#endif

XS(XS_Cairo__Surface_get_font_options); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_get_font_options)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::get_font_options", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_font_options_t *	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
#line 280 "CairoSurface.xs"
	RETVAL = cairo_font_options_create ();
	cairo_surface_get_font_options (surface, RETVAL);
#line 454 "CairoSurface.c"
	ST(0) = newSVCairoFontOptions (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__Surface_flush); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_flush)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::flush", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_surface_flush(surface);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__Surface_mark_dirty); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_mark_dirty)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::mark_dirty", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_surface_mark_dirty(surface);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__Surface_mark_dirty_rectangle); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_mark_dirty_rectangle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::mark_dirty_rectangle", "surface, x, y, width, height");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	int	x = (int)SvIV(ST(1));
	int	y = (int)SvIV(ST(2));
	int	width = (int)SvIV(ST(3));
	int	height = (int)SvIV(ST(4));

	cairo_surface_mark_dirty_rectangle(surface, x, y, width, height);
    }
    XSRETURN_EMPTY;
}

#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
#define XSubPPtmpAAAB 1


XS(XS_Cairo__Surface_get_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_get_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::get_type", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_type_t	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_surface_get_type(surface);
	ST(0) = newSVCairoSurfaceType (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__Surface_get_content); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_get_content)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::get_content", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_content_t	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_surface_get_content(surface);
	ST(0) = newSVCairoContent (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#endif
#ifdef CAIRO_HAS_PNG_FUNCTIONS
#define XSubPPtmpAAAC 1


XS(XS_Cairo__Surface_write_to_png); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_write_to_png)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::write_to_png", "surface, filename");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_status_t	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	const char *	filename = (const char *)SvPV_nolen(ST(1));

	RETVAL = cairo_surface_write_to_png(surface, filename);
	ST(0) = newSVCairoStatus (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__Surface_write_to_png_stream); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_write_to_png_stream)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::write_to_png_stream", "surface, func, data=NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 307 "CairoSurface.xs"
	CairoPerlCallback *callback;
#line 617 "CairoSurface.c"
	cairo_status_t	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	SV *	func = ST(1);
	SV *	data;

	if (items < 3)
	    data = NULL;
	else {
	    data = ST(2);
	}
#line 309 "CairoSurface.xs"
	callback = cairo_perl_callback_new (func, data);
	RETVAL = cairo_surface_write_to_png_stream (surface,
	                                            write_func_marshaller,
	                                            callback);
	cairo_perl_callback_free (callback);
#line 634 "CairoSurface.c"
	ST(0) = newSVCairoStatus (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#endif
#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE (1, 5, 8) /* FIXME: 1.6 */
#define XSubPPtmpAAAD 1


XS(XS_Cairo__Surface_copy_page); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_copy_page)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::copy_page", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_surface_copy_page(surface);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__Surface_show_page); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Surface_show_page)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Surface::show_page", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_surface_show_page(surface);
    }
    XSRETURN_EMPTY;
}

#endif

XS(XS_Cairo__ImageSurface_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::ImageSurface::create", "class, format, width, height");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t_noinc *	RETVAL;
	cairo_format_t	format = SvCairoFormat (ST(1));
	int	width = (int)SvIV(ST(2));
	int	height = (int)SvIV(ST(3));

	RETVAL = cairo_image_surface_create(format, width, height);
#line 339 "CairoSurface.xs"
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::ImageSurface");
#endif
#line 709 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__ImageSurface_create_for_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_create_for_data)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::ImageSurface::create_for_data", "class, data, format, width, height, stride");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t_noinc *	RETVAL;
	unsigned char *	data = (unsigned char *)SvPV_nolen(ST(1));
	cairo_format_t	format = SvCairoFormat (ST(2));
	int	width = (int)SvIV(ST(3));
	int	height = (int)SvIV(ST(4));
	int	stride = (int)SvIV(ST(5));

	RETVAL = cairo_image_surface_create_for_data(data, format, width, height, stride);
#line 348 "CairoSurface.xs"
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::ImageSurface");
#endif
#line 741 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
#define XSubPPtmpAAAE 1


XS(XS_Cairo__ImageSurface_get_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_get_data)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::ImageSurface::get_data", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 358 "CairoSurface.xs"
	unsigned char *data;
	int height, stride;
#line 767 "CairoSurface.c"
	SV *	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
#line 361 "CairoSurface.xs"
	data = cairo_image_surface_get_data (surface);
	height = cairo_image_surface_get_height (surface);
	stride = cairo_image_surface_get_stride (surface);
	RETVAL = data ? newSVpv ((char *) data, height * stride) : &PL_sv_undef;
#line 775 "CairoSurface.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__ImageSurface_get_format); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_get_format)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::ImageSurface::get_format", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_format_t	RETVAL;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_image_surface_get_format(surface);
	ST(0) = newSVCairoFormat (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#endif

XS(XS_Cairo__ImageSurface_get_width); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_get_width)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::ImageSurface::get_width", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_image_surface_get_width(surface);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Cairo__ImageSurface_get_height); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_get_height)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::ImageSurface::get_height", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_image_surface_get_height(surface);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
#define XSubPPtmpAAAF 1


XS(XS_Cairo__ImageSurface_get_stride); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_get_stride)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::ImageSurface::get_stride", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_image_surface_get_stride(surface);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#ifdef CAIRO_HAS_PNG_FUNCTIONS
#define XSubPPtmpAAAG 1


XS(XS_Cairo__ImageSurface_create_from_png); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_create_from_png)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::ImageSurface::create_from_png", "class, filename");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t_noinc *	RETVAL;
	const char *	filename = (const char *)SvPV_nolen(ST(1));

	RETVAL = cairo_image_surface_create_from_png(filename);
#line 389 "CairoSurface.xs"
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::ImageSurface");
#endif
#line 903 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__ImageSurface_create_from_png_stream); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__ImageSurface_create_from_png_stream)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::ImageSurface::create_from_png_stream", "class, func, data=NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 397 "CairoSurface.xs"
	CairoPerlCallback *callback;
#line 925 "CairoSurface.c"
	cairo_surface_t_noinc *	RETVAL;
	SV *	func = ST(1);
	SV *	data;

	if (items < 3)
	    data = NULL;
	else {
	    data = ST(2);
	}
#line 399 "CairoSurface.xs"
	callback = cairo_perl_callback_new (func, data);
	RETVAL = cairo_image_surface_create_from_png_stream (
			read_func_marshaller, callback);
	cairo_perl_callback_free (callback);
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::ImageSurface");
#endif
#line 943 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#endif
#ifdef CAIRO_HAS_PDF_SURFACE
#define XSubPPtmpAAAH 1


XS(XS_Cairo__PdfSurface_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PdfSurface_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::PdfSurface::create", "class, filename, width_in_points, height_in_points");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t_noinc *	RETVAL;
	const char *	filename = (const char *)SvPV_nolen(ST(1));
	double	width_in_points = (double)SvNV(ST(2));
	double	height_in_points = (double)SvNV(ST(3));

	RETVAL = cairo_pdf_surface_create(filename, width_in_points, height_in_points);
#line 425 "CairoSurface.xs"
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::PdfSurface");
#endif
#line 977 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__PdfSurface_create_for_stream); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PdfSurface_create_for_stream)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::PdfSurface::create_for_stream", "class, func, data, width_in_points, height_in_points");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 433 "CairoSurface.xs"
	CairoPerlCallback *callback;
#line 999 "CairoSurface.c"
	cairo_surface_t_noinc *	RETVAL;
	SV *	func = ST(1);
	SV *	data = ST(2);
	double	width_in_points = (double)SvNV(ST(3));
	double	height_in_points = (double)SvNV(ST(4));
#line 435 "CairoSurface.xs"
	callback = cairo_perl_callback_new (func, data);
	RETVAL = cairo_pdf_surface_create_for_stream (write_func_marshaller,
	                                              callback,
	                                              width_in_points,
	                                              height_in_points);
	cairo_surface_set_user_data (
		RETVAL, (const cairo_user_data_key_t *) &callback, callback,
		(cairo_destroy_func_t) cairo_perl_callback_free);
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::PdfSurface");
#endif
#line 1017 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
#define XSubPPtmpAAAI 1


XS(XS_Cairo__PdfSurface_set_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PdfSurface_set_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::PdfSurface::set_size", "surface, width_in_points, height_in_points");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	double	width_in_points = (double)SvNV(ST(1));
	double	height_in_points = (double)SvNV(ST(2));

	cairo_pdf_surface_set_size(surface, width_in_points, height_in_points);
    }
    XSRETURN_EMPTY;
}

#endif
#endif
#ifdef CAIRO_HAS_PS_SURFACE
#define XSubPPtmpAAAJ 1


XS(XS_Cairo__PsSurface_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::PsSurface::create", "class, filename, width_in_points, height_in_points");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t_noinc *	RETVAL;
	const char *	filename = (const char *)SvPV_nolen(ST(1));
	double	width_in_points = (double)SvNV(ST(2));
	double	height_in_points = (double)SvNV(ST(3));

	RETVAL = cairo_ps_surface_create(filename, width_in_points, height_in_points);
#line 471 "CairoSurface.xs"
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::PsSurface");
#endif
#line 1077 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__PsSurface_create_for_stream); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_create_for_stream)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::PsSurface::create_for_stream", "class, func, data, width_in_points, height_in_points");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 479 "CairoSurface.xs"
	CairoPerlCallback *callback;
#line 1099 "CairoSurface.c"
	cairo_surface_t_noinc *	RETVAL;
	SV *	func = ST(1);
	SV *	data = ST(2);
	double	width_in_points = (double)SvNV(ST(3));
	double	height_in_points = (double)SvNV(ST(4));
#line 481 "CairoSurface.xs"
	callback = cairo_perl_callback_new (func, data);
	RETVAL = cairo_ps_surface_create_for_stream (write_func_marshaller,
	                                             callback,
	                                             width_in_points,
	                                             height_in_points);
	cairo_surface_set_user_data (
		RETVAL, (const cairo_user_data_key_t *) &callback, callback,
		(cairo_destroy_func_t) cairo_perl_callback_free);
#if CAIRO_VERSION < CAIRO_VERSION_ENCODE(1, 2, 0)
	cairo_perl_package_table_insert (RETVAL, "Cairo::PsSurface");
#endif
#line 1117 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 2, 0)
#define XSubPPtmpAAAK 1


XS(XS_Cairo__PsSurface_set_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_set_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::PsSurface::set_size", "surface, width_in_points, height_in_points");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	double	width_in_points = (double)SvNV(ST(1));
	double	height_in_points = (double)SvNV(ST(2));

	cairo_ps_surface_set_size(surface, width_in_points, height_in_points);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__PsSurface_dsc_comment); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_dsc_comment)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::PsSurface::dsc_comment", "surface, comment");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	const char *	comment = (const char *)SvPV_nolen(ST(1));

	cairo_ps_surface_dsc_comment(surface, comment);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__PsSurface_dsc_begin_setup); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_dsc_begin_setup)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::PsSurface::dsc_begin_setup", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_ps_surface_dsc_begin_setup(surface);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__PsSurface_dsc_begin_page_setup); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_dsc_begin_page_setup)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::PsSurface::dsc_begin_page_setup", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	cairo_ps_surface_dsc_begin_page_setup(surface);
    }
    XSRETURN_EMPTY;
}

#endif
#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 5, 2) /* FIXME: 1.6 */
#define XSubPPtmpAAAL 1


XS(XS_Cairo__PsSurface_restrict_to_level); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_restrict_to_level)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::PsSurface::restrict_to_level", "surface, level");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	cairo_ps_level_t	level = SvCairoPsLevel (ST(1));

	cairo_ps_surface_restrict_to_level(surface, level);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__PsSurface_get_levels); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_get_levels)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::PsSurface::get_levels", "class=NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 515 "CairoSurface.xs"
	cairo_ps_level_t const *levels = NULL;
	int num_levels = 0, i;
#line 1253 "CairoSurface.c"
#line 518 "CairoSurface.xs"
	PERL_UNUSED_VAR (ax);
	cairo_ps_get_levels (&levels, &num_levels);
	EXTEND (sp, num_levels);
	for (i = 0; i < num_levels; i++)
		PUSHs (sv_2mortal (newSVCairoPsLevel (levels[i])));
#line 1260 "CairoSurface.c"
	PUTBACK;
	return;
    }
}


XS(XS_Cairo__PsSurface_level_to_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_level_to_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	RETVAL;
	dXSTARG;
#line 528 "CairoSurface.xs"
	if (items == 1) {
		RETVAL = cairo_ps_level_to_string (SvCairoPsLevel (ST (0)));
	} else if (items == 2) {
		RETVAL = cairo_ps_level_to_string (SvCairoPsLevel (ST (1)));
	} else {
		RETVAL = NULL;
		croak ("Usage: Cairo::PsSurface::level_to_string (level) or Cairo::PsSurface->level_to_string (level)");
	}
#line 1288 "CairoSurface.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Cairo__PsSurface_set_eps); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_set_eps)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::PsSurface::set_eps", "surface, eps");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	cairo_bool_t	eps = (cairo_bool_t)SvUV(ST(1));

	cairo_ps_surface_set_eps(surface, eps);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__PsSurface_get_eps); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__PsSurface_get_eps)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::PsSurface::get_eps", "surface");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_bool_t	RETVAL;
	dXSTARG;
	cairo_surface_t *	surface = SvCairoSurface (ST(0));

	RETVAL = cairo_ps_surface_get_eps(surface);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#endif
#ifdef CAIRO_HAS_SVG_SURFACE
#define XSubPPtmpAAAM 1


XS(XS_Cairo__SvgSurface_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__SvgSurface_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::SvgSurface::create", "class, filename, width_in_points, height_in_points");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t_noinc *	RETVAL;
	const char *	filename = (const char *)SvPV_nolen(ST(1));
	double	width_in_points = (double)SvNV(ST(2));
	double	height_in_points = (double)SvNV(ST(3));

	RETVAL = cairo_svg_surface_create(filename, width_in_points, height_in_points);
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__SvgSurface_create_for_stream); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__SvgSurface_create_for_stream)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::SvgSurface::create_for_stream", "class, func, data, width_in_points, height_in_points");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 569 "CairoSurface.xs"
	CairoPerlCallback *callback;
#line 1383 "CairoSurface.c"
	cairo_surface_t_noinc *	RETVAL;
	SV *	func = ST(1);
	SV *	data = ST(2);
	double	width_in_points = (double)SvNV(ST(3));
	double	height_in_points = (double)SvNV(ST(4));
#line 571 "CairoSurface.xs"
	callback = cairo_perl_callback_new (func, data);
	RETVAL = cairo_svg_surface_create_for_stream (write_func_marshaller,
						      callback,
						      width_in_points,
						      height_in_points);
	cairo_surface_set_user_data (
		RETVAL, (const cairo_user_data_key_t *) &callback, callback,
		(cairo_destroy_func_t) cairo_perl_callback_free);
#line 1398 "CairoSurface.c"
	ST(0) = newSVCairoSurface_noinc (RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Cairo__SvgSurface_restrict_to_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__SvgSurface_restrict_to_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::SvgSurface::restrict_to_version", "surface, version");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	cairo_surface_t *	surface = SvCairoSurface (ST(0));
	cairo_svg_version_t	version = SvCairoSvgVersion (ST(1));

	cairo_svg_surface_restrict_to_version(surface, version);
    }
    XSRETURN_EMPTY;
}


XS(XS_Cairo__SvgSurface_get_versions); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__SvgSurface_get_versions)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::SvgSurface::get_versions", "class=NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 588 "CairoSurface.xs"
	cairo_svg_version_t const *versions = NULL;
	int num_versions = 0, i;
#line 1444 "CairoSurface.c"
#line 591 "CairoSurface.xs"
	PERL_UNUSED_VAR (ax);
	cairo_svg_get_versions (&versions, &num_versions);
	EXTEND (sp, num_versions);
	for (i = 0; i < num_versions; i++)
		PUSHs (sv_2mortal (newSVCairoSvgVersion (versions[i])));
#line 1451 "CairoSurface.c"
	PUTBACK;
	return;
    }
}


XS(XS_Cairo__SvgSurface_version_to_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__SvgSurface_version_to_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	RETVAL;
	dXSTARG;
#line 601 "CairoSurface.xs"
	if (items == 1) {
		RETVAL = cairo_svg_version_to_string (SvCairoSvgVersion (ST (0)));
	} else if (items == 2) {
		RETVAL = cairo_svg_version_to_string (SvCairoSvgVersion (ST (1)));
	} else {
		RETVAL = NULL;
		croak ("Usage: Cairo::SvgSurface::version_to_string (version) or Cairo::SvgSurface->version_to_string (version)");
	}
#line 1479 "CairoSurface.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

#endif
#if CAIRO_VERSION >= CAIRO_VERSION_ENCODE(1, 5, 8) /* FIXME: 1.6 */
#define XSubPPtmpAAAN 1


XS(XS_Cairo__Format_stride_for_width); /* prototype to pass -Wmissing-prototypes */
XS(XS_Cairo__Format_stride_for_width)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Cairo::Format::stride_for_width", "format, width");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	cairo_format_t	format = SvCairoFormat (ST(0));
	int	width = (int)SvIV(ST(1));

	RETVAL = cairo_format_stride_for_width(format, width);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#ifdef __cplusplus
extern "C"
#endif
XS(boot_Cairo__Surface); /* prototype to pass -Wmissing-prototypes */
XS(boot_Cairo__Surface)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("Cairo::Surface::DESTROY", XS_Cairo__Surface_DESTROY, file);
        newXS("Cairo::Surface::create_similar", XS_Cairo__Surface_create_similar, file);
        newXS("Cairo::Surface::finish", XS_Cairo__Surface_finish, file);
        newXS("Cairo::Surface::status", XS_Cairo__Surface_status, file);
        newXS("Cairo::Surface::set_device_offset", XS_Cairo__Surface_set_device_offset, file);
#if XSubPPtmpAAAA
        newXS("Cairo::Surface::get_device_offset", XS_Cairo__Surface_get_device_offset, file);
        newXS("Cairo::Surface::set_fallback_resolution", XS_Cairo__Surface_set_fallback_resolution, file);
#endif
        newXS("Cairo::Surface::get_font_options", XS_Cairo__Surface_get_font_options, file);
        newXS("Cairo::Surface::flush", XS_Cairo__Surface_flush, file);
        newXS("Cairo::Surface::mark_dirty", XS_Cairo__Surface_mark_dirty, file);
        newXS("Cairo::Surface::mark_dirty_rectangle", XS_Cairo__Surface_mark_dirty_rectangle, file);
#if XSubPPtmpAAAB
        newXS("Cairo::Surface::get_type", XS_Cairo__Surface_get_type, file);
        newXS("Cairo::Surface::get_content", XS_Cairo__Surface_get_content, file);
#endif
#if XSubPPtmpAAAC
        newXS("Cairo::Surface::write_to_png", XS_Cairo__Surface_write_to_png, file);
        newXS("Cairo::Surface::write_to_png_stream", XS_Cairo__Surface_write_to_png_stream, file);
#endif
#if XSubPPtmpAAAD
        newXS("Cairo::Surface::copy_page", XS_Cairo__Surface_copy_page, file);
        newXS("Cairo::Surface::show_page", XS_Cairo__Surface_show_page, file);
#endif
        newXS("Cairo::ImageSurface::create", XS_Cairo__ImageSurface_create, file);
        newXS("Cairo::ImageSurface::create_for_data", XS_Cairo__ImageSurface_create_for_data, file);
#if XSubPPtmpAAAE
        newXS("Cairo::ImageSurface::get_data", XS_Cairo__ImageSurface_get_data, file);
        newXS("Cairo::ImageSurface::get_format", XS_Cairo__ImageSurface_get_format, file);
#endif
        newXS("Cairo::ImageSurface::get_width", XS_Cairo__ImageSurface_get_width, file);
        newXS("Cairo::ImageSurface::get_height", XS_Cairo__ImageSurface_get_height, file);
#if XSubPPtmpAAAF
        newXS("Cairo::ImageSurface::get_stride", XS_Cairo__ImageSurface_get_stride, file);
#endif
#if XSubPPtmpAAAG
        newXS("Cairo::ImageSurface::create_from_png", XS_Cairo__ImageSurface_create_from_png, file);
        newXS("Cairo::ImageSurface::create_from_png_stream", XS_Cairo__ImageSurface_create_from_png_stream, file);
#endif
#if XSubPPtmpAAAH
        newXS("Cairo::PdfSurface::create", XS_Cairo__PdfSurface_create, file);
        newXS("Cairo::PdfSurface::create_for_stream", XS_Cairo__PdfSurface_create_for_stream, file);
#if XSubPPtmpAAAI
        newXS("Cairo::PdfSurface::set_size", XS_Cairo__PdfSurface_set_size, file);
#endif
#endif
#if XSubPPtmpAAAJ
        newXS("Cairo::PsSurface::create", XS_Cairo__PsSurface_create, file);
        newXS("Cairo::PsSurface::create_for_stream", XS_Cairo__PsSurface_create_for_stream, file);
#if XSubPPtmpAAAK
        newXS("Cairo::PsSurface::set_size", XS_Cairo__PsSurface_set_size, file);
        newXS("Cairo::PsSurface::dsc_comment", XS_Cairo__PsSurface_dsc_comment, file);
        newXS("Cairo::PsSurface::dsc_begin_setup", XS_Cairo__PsSurface_dsc_begin_setup, file);
        newXS("Cairo::PsSurface::dsc_begin_page_setup", XS_Cairo__PsSurface_dsc_begin_page_setup, file);
#endif
#if XSubPPtmpAAAL
        newXS("Cairo::PsSurface::restrict_to_level", XS_Cairo__PsSurface_restrict_to_level, file);
        newXS("Cairo::PsSurface::get_levels", XS_Cairo__PsSurface_get_levels, file);
        newXS("Cairo::PsSurface::level_to_string", XS_Cairo__PsSurface_level_to_string, file);
        newXS("Cairo::PsSurface::set_eps", XS_Cairo__PsSurface_set_eps, file);
        newXS("Cairo::PsSurface::get_eps", XS_Cairo__PsSurface_get_eps, file);
#endif
#endif
#if XSubPPtmpAAAM
        newXS("Cairo::SvgSurface::create", XS_Cairo__SvgSurface_create, file);
        newXS("Cairo::SvgSurface::create_for_stream", XS_Cairo__SvgSurface_create_for_stream, file);
        newXS("Cairo::SvgSurface::restrict_to_version", XS_Cairo__SvgSurface_restrict_to_version, file);
        newXS("Cairo::SvgSurface::get_versions", XS_Cairo__SvgSurface_get_versions, file);
        newXS("Cairo::SvgSurface::version_to_string", XS_Cairo__SvgSurface_version_to_string, file);
#endif
#if XSubPPtmpAAAN
        newXS("Cairo::Format::stride_for_width", XS_Cairo__Format_stride_for_width, file);
#endif

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#line 332 "CairoSurface.xs"
	cairo_perl_set_isa ("Cairo::ImageSurface", "Cairo::Surface");

#if XSubPPtmpAAAE
#endif
#if XSubPPtmpAAAF
#endif
#if XSubPPtmpAAAG
#endif
#if XSubPPtmpAAAH
#line 418 "CairoSurface.xs"
	cairo_perl_set_isa ("Cairo::PdfSurface", "Cairo::Surface");

#if XSubPPtmpAAAI
#endif
#endif
#if XSubPPtmpAAAJ
#line 464 "CairoSurface.xs"
	cairo_perl_set_isa ("Cairo::PsSurface", "Cairo::Surface");

#if XSubPPtmpAAAK
#endif
#if XSubPPtmpAAAL
#endif
#endif
#if XSubPPtmpAAAM
#line 557 "CairoSurface.xs"
	cairo_perl_set_isa ("Cairo::SvgSurface", "Cairo::Surface");

#endif
#if XSubPPtmpAAAN
#endif
#line 1648 "CairoSurface.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

